#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLINE 1024

int main(int argc, char **argv)
{
	int socket_fd, num_bytes_sent, num_bytes_received;
	char data[MAXLINE], host_reply[MAXLINE];
	struct sockaddr_in server_address;

	if (argc != 3) 
	{
		fprintf(stderr, "Usage: %s <Server IP Address> <Message>\n", argv[0]);
		exit(1); 
	}

	bzero(&server_address, sizeof(server_address));
	server_address.sin_family = AF_INET;
	server_address.sin_port = htons(1989);

	if (inet_pton(AF_INET, argv[1], &server_address.sin_addr) <= 0)
	{
		fprintf(stderr, "inet_pton error.\n");
		exit(1);
	}

	if ((socket_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		fprintf(stderr, "socket error.\n");
		exit(1);
	}

	if (connect(socket_fd, (struct sockaddr *) &server_address, sizeof(server_address)) < 0)
	{
		fprintf(stderr, "connect error.\n");
		exit(1);
	}

	strcpy(data, argv[2]);

	if ((num_bytes_sent = send(socket_fd, data, strlen(data), 0)) == 0)
	{
		fprintf(stderr, "send error.\n");
	}

	printf("Sent %d bytes (should be %d)\n", num_bytes_sent, strlen(data));
	num_bytes_received = recv(socket_fd, host_reply, MAXLINE, 0);
	host_reply[num_bytes_received] = '\0';

	if (num_bytes_received == 0) 
	{
		fprintf(stderr, "recv error.\n");
		exit(1);
	}

	printf("Received %d bytes (should be %d)\n", num_bytes_received,
	strlen(data));

	printf("Server replies: %s\n", host_reply);

	close(socket_fd);
	return 0;
}
