#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLINE 1024
#define LISTENQ 1024

int main (void)
{
	int listenfd, connfd;
	struct sockaddr_in servaddr, clieaddr;
	socklen_t len;
	char buffer[MAXLINE], client_message[MAXLINE];
	int num_bytes_received, num_bytes_sent, temp;

	bzero (&servaddr, sizeof (servaddr));
	servaddr.sin_family = AF_INET;
	servaddr.sin_addr.s_addr = htonl (INADDR_ANY);
	servaddr.sin_port = htons (1989);

	listenfd = socket (AF_INET, SOCK_STREAM, 0);
	if (listenfd < 0) 
	{
		fprintf(stderr, "socket error\n");
		exit(1);
	}
	
	if (bind (listenfd,(struct sockaddr *) &servaddr, sizeof (servaddr)) != 0) 
	{
		fprintf(stderr, "bind error\n");
		exit(1);
	}
	
	if (listen (listenfd, LISTENQ) != 0) 
	{
		fprintf(stderr, "listen error\n");
		exit(1);
	}

	while (1) 
	{
		
		connfd = accept (listenfd,(struct sockaddr *) &clieaddr, &len);
		if (connfd < 0) 
		{
			fprintf(stderr, "accept error\n");
			exit(1);
		}

		printf ("Connection accepted from %s on port %d.\n", inet_ntop (AF_INET, &clieaddr.sin_addr, buffer, sizeof (buffer)), ntohs (clieaddr.sin_port));

		num_bytes_received = recv(connfd, client_message, MAXLINE, 0);
		client_message[num_bytes_received] = 0;
		if (num_bytes_received < 0) 
		{
			fprintf(stderr, "recv error\n");
			exit(1);
		}

		printf ("message from client: %s\n", client_message);

		num_bytes_sent = send (connfd, client_message, strlen(client_message), 0);
		if (num_bytes_sent < 0) 
		{
			fprintf(stderr, "send error");
			exit(1);
		}
		printf("Sent %d bytes (should be %d)\n", num_bytes_sent, num_bytes_received);
		
		close(connfd);
	}

	return 0;
}
